#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "imageInput.h"

#define BUFFER_SIZE 100
#define FILE_HEADER_STRING "__info2_image_file_format__"

// TODO Implementieren Sie geeignete Hilfsfunktionen für das Lesen der Bildserie aus einer Datei
static int checkFileHeader(FILE *fp)
{
    if (!fp) // Datei konnte nicht geöffnet werden
        return 0; 

    char buffer[BUFFER_SIZE];
    size_t headerLen = strlen(FILE_HEADER_STRING);
    if (headerLen >= BUFFER_SIZE) // Safety Check
        return 0; 

    if (fread(buffer, 1, headerLen, fp) != headerLen) 
        return 0;

    buffer[headerLen] = '\0';
    if (strcmp(buffer, FILE_HEADER_STRING) != 0) 
        return 0;

    return 1; // Header stimmt
}

// TODO Vervollständigen Sie die Funktion readImages unter Benutzung Ihrer Hilfsfunktionen
GrayScaleImageSeries *readImages(const char *path)
{
    GrayScaleImageSeries *series = NULL;
    
    return series;
}

// TODO Vervollständigen Sie die Funktion clearSeries, welche eine Bildserie vollständig aus dem Speicher freigibt
void clearSeries(GrayScaleImageSeries *series)
{
    if (series == NULL) 
        return;
    
    free(series->images);
    free(series->labels);
    free(series);
}